global open_return 
global model_type
global tutor_wait

frame .control_panel.o_frame

tk_optionMenu .control_panel.o_frame.open_option model_type Existing New "Tutor 1.1" "Tutor 1.2"
.control_panel.o_frame.open_option configure -font menu_font


button .control_panel.o_frame.open -text "Open Model:" \
       -font button_font -command {
  global local_connection
  global current_open_model
  global model_type

  if {$local_connection == 0} {
    tk_messageBox -icon warning -type ok -title "Open warning" \
                  -message "You cannot use the Open Model button if the\
                            environment is not running on the same machine\
                            as ACT-R at this time, but if you want such a\
                            feature let Dan know because there are a couple\
                            of ways such a feature could be added."  
  } elseif {$current_open_model != ""} {
    tk_messageBox -icon warning -type ok -title "Open warning" \
                  -message "You must close the current model before you\
                            can open another one."
  } else {
    switch -- $model_type {
      Existing {
        set fname [tk_getOpenFile -title "Model to open" \
                            -filetypes {{"All Files" *}}] 
   
        if {$fname != ""} {
          open_model_file $fname
        }
      }
      New {
        set fname [tk_getSaveFile -title "Save new model as"\
                                  -filetypes {{"All Files" *}}]
        if {$fname != ""} {
          write_data "(clear-all)\n(pm-reset)" $fname
          open_model_file $fname
        }
      }
      "Tutor 1.1" {
        set fname [tk_getSaveFile -title "Save new model as"\
                                  -filetypes {{"All Files" *}}]
        if {$fname != ""} {
          write_data "(clear-all)\n(pm-reset)" $fname
          open_tutor1 $fname
        }
      }

      "Tutor 1.2" {
        set fname [tk_getSaveFile -title "Save new model as"\
                                  -filetypes {{"All Files" *}}]
        if {$fname != ""} {
          write_data "(clear-all)\n(pm-reset)" $fname
          open_tutor2 $fname
        }
      }
    }
  }
}
 
pack .control_panel.o_frame.open -side left
pack .control_panel.o_frame.open_option -side left

pack .control_panel.o_frame

send_environment_cmd \
  "create list-handler .control_panel.o_frame.open\
     open_return (lambda (x)) ()"

bind .control_panel.o_frame.open <Destroy> {
  remove_handler %W
}


proc open_model_file {fname} {
  global open_return
  global current_open_model
  global current_open_model_name
  global top_dir
  global options_array
  global tutor_mode
 
  set open_return ""

  send_environment_cmd \
    "update [get_handler_name .control_panel.o_frame.open] \
      (lambda (x) \
        (unwind-protect \ 
           (unless *running-actr* \
             (setf *running-actr* t) \
             (let ((result (if $options_array(use_smart_load) \
                               (smart-loader \"$fname\")
                             (safe-load \"$fname\")))) \
                (setf *running-actr* nil) \
                (format t (if (= 1 (first result)) \
                            \"~%#|## Model $fname loaded. ##|#~%\" \
                            \"~%#|## Failed loading model $fname. ##|#~%\")) \     
                result)) \
             (setf *running-actr* nil)))"
 
  wait_for_non_null open_return
           
       set win [toplevel [new_variable_name .reload_response]]
  
  # hide the window for speed and aesthetic reasons
  
  wm withdraw $win

  wm geometry $win [get_configuration .reload_response $win]


 set text_frame [frame $win.text_frame -borderwidth 0]  
 
 set text_box [text $text_frame.text -yscrollcommand \
                     "$text_frame.text_scrl set" -state normal \
                     -font text_font]
  
  
  
  set text_scroll_bar [scrollbar $text_frame.text_scrl \
                                 -command "$text_box yview"]


  set the_button [button $win.but -text "Ok" -command "destroy $win"]

  place $text_frame -x 0 -y 0 -relheight 1.0 -height -30 -relwidth 1.0
  place $the_button -relx .5 -x -30 -width 60 -rely 1.0 -y -30 -height 30

  pack $text_scroll_bar -side right -fill y
  pack $text_box -side left -expand 1 -fill both


  if {[lindex $open_return 0] == 0} {
       wm title $win "ERROR Opening"
    $text_box insert 1.0 "Error:\n[lindex $open_return 1]"

    wm deiconify $win
    focus $win

  } else {
    wm title $win "SUCCESSFUL Load"
    $text_box insert 1.0 "Successful Load:\n[lindex $open_return 1]"

      wm deiconify $win
      focus $win
      
      tkwait window $win 



    set open_return ""
    
    send_environment_cmd \
      "update [get_handler_name .control_panel.o_frame.open] \
         (lambda (x) (split-model-file \"$fname\") (list 1 1))"
 
    wait_for_non_null open_return

    set current_open_model $fname
    set current_open_model_name [file tail $fname]
    set tutor_mode 0

    if {$options_array(open_as_split) == 1} {
      edit_model_file .chunk_type [file join $top_dir "chunk-type.lisp"] 1
      edit_model_file .chunk [file join $top_dir "chunk.lisp"] 1
      edit_model_file .production [file join $top_dir "production.lisp"] 1
      edit_model_file .misc [file join $top_dir "misc.lisp"] 1
      edit_model_file .command [file join $top_dir "command.lisp"] 1
    } else {
      edit_model_file .model $fname 1
    }
  }
}

set pmatch_id ""

proc edit_model_file {win_name file_name reload} {
  global model_file_names
  global model_file_changed
  global tutor_mode
              
  if {[winfo exists $win_name] == 1} {
     wm deiconify $win_name
     raise $win_name

     if {$reload == 1} {
       set data [read_file $file_name]

       $win_name.frame.text delete 1.0 end
       $win_name.frame.text insert end $data
     }
  } else {
     toplevel $win_name

     wm withdraw $win_name
     
     wm geometry $win_name [get_configuration $win_name]
   
     wm title $win_name [file tail [file rootname $file_name]]

     # create a text_box to hold the output and put it in the window
     # also need a frame to hold it and the scroll bar

     frame $win_name.frame -borderwidth 0  
    
      set text_box [text $win_name.frame.text -yscrollcommand \
          "$win_name.frame.vscrl set" -xscrollcommand \
          "$win_name.frame.hscrl set" -font text_font -wrap none]
          
      set model_file_names($text_box) $file_name

      set v_scrl_bar [scrollbar $win_name.frame.vscrl -command \
            "$win_name.frame.text yview"]
   
      set h_scrl_bar [scrollbar $win_name.frame.hscrl -command \
            "$win_name.frame.text xview" -orient horizontal]
   
      place $win_name.frame -x 0 -y 0 -relwidth 1.0 -relheight 1.0
        
      pack $v_scrl_bar -side right -fill y 
      pack $h_scrl_bar -side bottom -fill x 
      pack $text_box -side left -expand 1 -fill both

      set data [read_file $file_name]

      if {$data != ""} {
        $text_box delete 1.0 end
        $text_box insert end $data
      }

      set model_file_changed($text_box) 0

      bind $text_box <KeyPress-parenright> {
        global model_file_changed
        
        set model_file_changed(%W) 1
        
        set start [%W index insert]
        
        set paren_count 1
        set index_count 0
        set hit_start 0

        while { $paren_count != 0 && $hit_start == 0} {
         
          incr index_count 1

          set cur_char [%W get "$start - $index_count chars"]
          
          if {[%W index "$start - $index_count chars"] == [%W index 1.0]} {
            set hit_start 1
          }

          if { $cur_char == ")" } {
            incr paren_count 1
          } elseif {$cur_char == "(" } {
            incr paren_count -1
          }
       }

       global pmatch_id       

       if {$paren_count == 0} {
          if {[lsearch -exact [%W tag names] pmatch] != -1} {
            after cancel $pmatch_id
            %W tag delete pmatch
          }

          %W tag add pmatch "$start - $index_count chars"
          %W tag configure pmatch -underline 1
          
          set pmatch_id [after 300 {%W tag delete pmatch}]
       }
      }

      bind $text_box <KeyPress-parenleft> {
        global model_file_changed
        
        set model_file_changed(%W) 1
        
        set start [%W index insert]
        
        set paren_count 1
        set index_count -1
        set hit_end 0

        while { $paren_count != 0 && $hit_end == 0} {
         
          incr index_count 1

          set cur_char [%W get "$start + $index_count chars"]
          
          if {[%W index "$start + $index_count chars"] == [%W index end]} {
            set hit_end 1
          }

          if { $cur_char == "(" } {
            incr paren_count 1
          } elseif {$cur_char == ")" } {
            incr paren_count -1
          }
       }

       global pmatch_id       

       if {$paren_count == 0} {
          if {[lsearch -exact [%W tag names] pmatch] != -1} {
            after cancel $pmatch_id
            %W tag delete pmatch
          }

          %W tag add pmatch "$start + $index_count chars"
          %W tag configure pmatch -underline 1
          
          set pmatch_id [after 300 {%W tag delete pmatch}]
       }
      }
   
      bind $text_box <KeyPress> {
        global model_file_changed
        
        set model_file_changed(%W) 1

        if $tutor_mode {
          handle_tutor_entry %W %K
        }
      }
        
      bind $text_box <Key-F1> {
        
        if $tutor_mode {
          report_tutor_help %W
        }
      }

      wm protocol $win_name WM_DELETE_WINDOW "prompt_close_text $win_name"
         

      wm deiconify $win_name
      raise $win_name
  }
} 
 

proc prompt_close_text {win} {
  global model_file_names
  global model_file_changed

  if {$model_file_changed($win.frame.text) == 1} {
    set answer \
      [tk_messageBox -icon warning -title \
                     "Closing [file tail $model_file_names($win.frame.text)]" \
                     -message "Save contents before closing?" \
                     -type yesnocancel]

    switch -- $answer {
      yes {
        save_text $win.frame.text $model_file_names($win.frame.text)
        destroy $win
      }
      no {
        destroy $win 
      }
    }
  } else {
    destroy $win
  }
}



proc open_tutor1 {fname} {
  global open_return
  global current_open_model
  global current_open_model_name
  global top_dir
  global options_array
  global tutor_mode
  global tutor_windows
  global tutor_state
  global tutor_answers  
  global tutor_started
  global tutor_count
  global tutor_complete
  global tutor_response

  set tutor_mode 1
  set tutor_windows [list "chunk_type" "chunk"]

  set open_return ""

  send_environment_cmd \
    "update [get_handler_name .control_panel.o_frame.open] \
      (lambda (x) \
        (unwind-protect \ 
           (unless *running-actr* \
             (setf *running-actr* t) \
             (let ((result (safe-load \"$fname\"))) \
                (setf *running-actr* nil) \
                (format t (if (= 1 (first result)) \
                            \"~%#|## Model $fname loaded. ##|#~%\" \
                            \"~%#|## Failed loading model $fname. ##|#~%\")) \     
                result)) \
             (setf *running-actr* nil)))"
 
  wait_for_non_null open_return
           
  set open_return ""
    
  send_environment_cmd \
      "update [get_handler_name .control_panel.o_frame.open] \
         (lambda (x) (split-model-file \"$fname\") (list 1 1))"
 
    wait_for_non_null open_return

    set current_open_model $fname
    set current_open_model_name [file tail $fname]

    edit_model_file .chunk_type [file join $top_dir "chunk-type.lisp"] 1
    edit_model_file .chunk [file join $top_dir "chunk.lisp"] 1

    .chunk_type.frame.text insert 1.0 "(chunk-type {name})\n"
    .chunk.frame.text insert 1.0 "(add-dm\n  ({name})\n)\n"

    .chunk_type.frame.text tag add tutor 1.12 1.18
    .chunk.frame.text tag add tutor 2.3 2.9

    .chunk_type.frame.text tag configure tutor -background black -foreground white
    .chunk.frame.text tag configure tutor -background black -foreground white

    set tutor_state(.chunk.frame.text) name
    set tutor_state(.chunk_type.frame.text) name

    set tutor_started(.chunk.frame.text) 0
    set tutor_started(.chunk_type.frame.text) 0

    set tutor_response(.chunk.frame.text) "0.0"
    set tutor_response(.chunk_type.frame.text) "0.0"
    
    focus .chunk_type.frame.text
    
    set tutor_count 0
    set tutor_complete 2

    set tutor_answers(.chunk_type.frame.text) {{ADDITION-FACT ADDEND1 ADDEND2 SUM} \
                                                {add-pair ten1 one1 ten2 one2 carry ten-ans one-ans} \
                                                {NUMBER VALUE}} 

    set tutor_answers(.chunk.frame.text)       {{THREE NUMBER {VALUE 3}} \
                                                {FOUR NUMBER {VALUE 4}} \
                                                {SEVEN NUMBER {VALUE 7}} \
                                                {EIGHT NUMBER {VALUE 8}} \
                                                {FACT34 ADDITION-FACT {ADDEND1 THREE} {ADDEND2 FOUR} {SUM SEVEN}} \
                                                {FACT43 ADDITION-FACT {ADDEND1 FOUR} {ADDEND2 THREE} {SUM SEVEN}} \
                                                {FACT44 ADDITION-FACT {ADDEND1 FOUR} {ADDEND2 FOUR} {SUM EIGHT}} \
                                                {goal add-pair {ten1 three} {one1 six} {ten2 four} {one2 seven}}}

  
}


proc open_tutor2 {fname} {
   global open_return
  global current_open_model
  global current_open_model_name
  global top_dir
  global options_array
  global tutor_mode
  global tutor_windows
  global tutor_state
  global tutor_answers  
  global tutor_started
  global tutor_count
  global tutor_complete
  global tutor_response

  set tutor_mode 1
  set tutor_windows [list "chunk_type" "chunk" "production" "command"]

  set open_return ""

  send_environment_cmd \
    "update [get_handler_name .control_panel.o_frame.open] \
      (lambda (x) \
        (unwind-protect \ 
           (unless *running-actr* \
             (setf *running-actr* t) \
             (let ((result (safe-load \"$fname\"))) \
                (setf *running-actr* nil) \
                (format t (if (= 1 (first result)) \
                            \"~%#|## Model $fname loaded. ##|#~%\" \
                            \"~%#|## Failed loading model $fname. ##|#~%\")) \     
                result)) \
             (setf *running-actr* nil)))"
 
  wait_for_non_null open_return
           
  set open_return ""
    
  send_environment_cmd \
      "update [get_handler_name .control_panel.o_frame.open] \
         (lambda (x) (split-model-file \"$fname\") (list 1 1))"
 
    wait_for_non_null open_return

    set current_open_model $fname
    set current_open_model_name [file tail $fname]

    edit_model_file .chunk_type [file join $top_dir "chunk-type.lisp"] 1
    edit_model_file .chunk [file join $top_dir "chunk.lisp"] 1
    edit_model_file .production [file join $top_dir "production.lisp"] 1
    edit_model_file .command [file join $top_dir "command.lisp"] 1

    .chunk_type.frame.text insert 1.0 "(chunk-type addition-fact addend1 addend2 sum)\n(chunk-type number value)\n(chunk-type add-pair ten1 one1 ten2 one2 carry ten-ans one-ans)\n"

    .chunk.frame.text insert 1.0 "(add-dm\n\
   (waiting isa chunk)\n\
   (goal isa add-pair ten1 three one1 six ten2 four one2 seven)\n\
   (fact00 isa addition-fact addend1 zero addend2 zero sum zero)\n\
   (fact01 isa addition-fact addend1 zero addend2 one sum one)\n\
   (fact02 isa addition-fact addend1 zero addend2 two sum two)\n\
   (fact03 isa addition-fact addend1 zero addend2 three sum three)\n\
   (fact04 isa addition-fact addend1 zero addend2 four sum four)\n\
   (fact05 isa addition-fact addend1 zero addend2 five sum five)\n\
   (fact06 isa addition-fact addend1 zero addend2 six sum six)\n\
   (fact07 isa addition-fact addend1 zero addend2 seven sum seven)\n\
   (fact08 isa addition-fact addend1 zero addend2 eight sum eight)\n\
   (fact09 isa addition-fact addend1 zero addend2 nine sum nine)\n\
   (fact10 isa addition-fact addend1 one addend2 zero sum one)\n\
   (fact11 isa addition-fact addend1 one addend2 one sum two)\n\
   (fact12 isa addition-fact addend1 one addend2 two sum three)\n\
   (fact13 isa addition-fact addend1 one addend2 three sum four)\n\
   (fact14 isa addition-fact addend1 one addend2 four sum five)\n\
   (fact15 isa addition-fact addend1 one addend2 five sum six)\n\
   (fact16 isa addition-fact addend1 one addend2 six sum seven)\n\
   (fact17 isa addition-fact addend1 one addend2 seven sum eight)\n\
   (fact18 isa addition-fact addend1 one addend2 eight sum nine)\n\
   (fact19 isa addition-fact addend1 one addend2 nine sum ten)\n\
   (fact20 isa addition-fact addend1 two addend2 zero sum two)\n\
   (fact21 isa addition-fact addend1 two addend2 one sum three)\n\
   (fact22 isa addition-fact addend1 two addend2 two sum four)\n\
   (fact23 isa addition-fact addend1 two addend2 three sum five)\n\
   (fact24 isa addition-fact addend1 two addend2 four sum six)\n\
   (fact25 isa addition-fact addend1 two addend2 five sum seven)\n\
   (fact26 isa addition-fact addend1 two addend2 six sum eight)\n\
   (fact27 isa addition-fact addend1 two addend2 seven sum nine)\n\
   (fact28 isa addition-fact addend1 two addend2 eight sum ten)\n\
   (fact29 isa addition-fact addend1 two addend2 nine sum eleven)\n\
   (fact30 isa addition-fact addend1 three addend2 zero sum three)\n\
   (fact31 isa addition-fact addend1 three addend2 one sum four)\n\
   (fact32 isa addition-fact addend1 three addend2 two sum five)\n\
   (fact33 isa addition-fact addend1 three addend2 three sum six)\n\
   (fact34 isa addition-fact addend1 three addend2 four sum seven)\n\
   (fact35 isa addition-fact addend1 three addend2 five sum eight)\n\
   (fact36 isa addition-fact addend1 three addend2 six sum nine)\n\
   (fact37 isa addition-fact addend1 three addend2 seven sum ten)\n\
   (fact38 isa addition-fact addend1 three addend2 eight sum eleven)\n\
   (fact39 isa addition-fact addend1 three addend2 nine sum twelve)\n\
   (fact40 isa addition-fact addend1 four addend2 zero sum four)\n\
   (fact41 isa addition-fact addend1 four addend2 one sum five)\n\
   (fact42 isa addition-fact addend1 four addend2 two sum six)\n\
   (fact43 isa addition-fact addend1 four addend2 three sum seven)\n\
   (fact44 isa addition-fact addend1 four addend2 four sum eight)\n\
   (fact45 isa addition-fact addend1 four addend2 five sum nine)\n\
   (fact46 isa addition-fact addend1 four addend2 six sum ten)\n\
   (fact47 isa addition-fact addend1 four addend2 seven sum eleven)\n\
   (fact48 isa addition-fact addend1 four addend2 eight sum twelve)\n\
   (fact49 isa addition-fact addend1 four addend2 nine sum thirteen)\n\
   (fact50 isa addition-fact addend1 five addend2 zero sum five)\n\
   (fact51 isa addition-fact addend1 five addend2 one sum six)\n\
   (fact52 isa addition-fact addend1 five addend2 two sum seven)\n\
   (fact53 isa addition-fact addend1 five addend2 three sum eight)\n\
   (fact54 isa addition-fact addend1 five addend2 four sum nine)\n\
   (fact55 isa addition-fact addend1 five addend2 five sum ten)\n\
   (fact56 isa addition-fact addend1 five addend2 six sum eleven)\n\
   (fact57 isa addition-fact addend1 five addend2 seven sum twelve)\n\
   (fact58 isa addition-fact addend1 five addend2 eight sum thirteen)\n\
   (fact59 isa addition-fact addend1 five addend2 nine sum fourteen)\n\
   (fact60 isa addition-fact addend1 six addend2 zero sum six)\n\
   (fact61 isa addition-fact addend1 six addend2 one sum seven)\n\
   (fact62 isa addition-fact addend1 six addend2 two sum eight)\n\
   (fact63 isa addition-fact addend1 six addend2 three sum nine)\n\
   (fact64 isa addition-fact addend1 six addend2 four sum ten)\n\
   (fact65 isa addition-fact addend1 six addend2 five sum eleven)\n\
   (fact66 isa addition-fact addend1 six addend2 six sum twelve)\n\
   (fact67 isa addition-fact addend1 six addend2 seven sum thirteen)\n\
   (fact68 isa addition-fact addend1 six addend2 eight sum fourteen)\n\
   (fact69 isa addition-fact addend1 six addend2 nine sum fifteen)\n\
   (fact70 isa addition-fact addend1 seven addend2 zero sum seven)\n\
   (fact71 isa addition-fact addend1 seven addend2 one sum eight)\n\
   (fact72 isa addition-fact addend1 seven addend2 two sum nine)\n\
   (fact73 isa addition-fact addend1 seven addend2 three sum ten)\n\
   (fact74 isa addition-fact addend1 seven addend2 four sum eleven)\n\
   (fact75 isa addition-fact addend1 seven addend2 five sum twelve)\n\
   (fact76 isa addition-fact addend1 seven addend2 six sum thirteen)\n\
   (fact77 isa addition-fact addend1 seven addend2 seven sum fourteen)\n\
   (fact78 isa addition-fact addend1 seven addend2 eight sum fifteen)\n\
   (fact79 isa addition-fact addend1 seven addend2 nine sum sixteen)\n\
   (fact80 isa addition-fact addend1 eight addend2 zero sum eight)\n\
   (fact81 isa addition-fact addend1 eight addend2 one sum nine)\n\
   (fact82 isa addition-fact addend1 eight addend2 two sum ten)\n\
   (fact83 isa addition-fact addend1 eight addend2 three sum eleven)\n\
   (fact84 isa addition-fact addend1 eight addend2 four sum twelve)\n\
   (fact85 isa addition-fact addend1 eight addend2 five sum thirteen)\n\
   (fact86 isa addition-fact addend1 eight addend2 six sum fourteen)\n\
   (fact87 isa addition-fact addend1 eight addend2 seven sum fifteen)\n\
   (fact88 isa addition-fact addend1 eight addend2 eight sum sixteen)\n\
   (fact89 isa addition-fact addend1 eight addend2 nine sum seventeen)\n\
   (fact90 isa addition-fact addend1 nine addend2 zero sum nine)\n\
   (fact91 isa addition-fact addend1 nine addend2 one sum ten)\n\
   (fact92 isa addition-fact addend1 nine addend2 two sum eleven)\n\
   (fact93 isa addition-fact addend1 nine addend2 three sum twelve)\n\
   (fact94 isa addition-fact addend1 nine addend2 four sum thirteen)\n\
   (fact95 isa addition-fact addend1 nine addend2 five sum fourteen)\n\
   (fact96 isa addition-fact addend1 nine addend2 six sum fifteen)\n\
   (fact97 isa addition-fact addend1 nine addend2 seven sum sixteen)\n\
   (fact98 isa addition-fact addend1 nine addend2 eight sum seventeen)\n\
   (fact99 isa addition-fact addend1 nine addend2 nine sum eightteen)\n\
   (fact100 isa addition-fact addend1 ten addend2 zero sum ten)\n\
   (fact101 isa addition-fact addend1 ten addend2 one sum eleven)\n\
   (fact102 isa addition-fact addend1 ten addend2 two sum twelve)\n\
   (fact103 isa addition-fact addend1 ten addend2 three sum thirteen)\n\
   (fact104 isa addition-fact addend1 ten addend2 four sum fourteen)\n\
   (fact105 isa addition-fact addend1 ten addend2 five sum fifteen)\n\
   (fact106 isa addition-fact addend1 ten addend2 six sum sixteen)\n\
   (fact107 isa addition-fact addend1 ten addend2 seven sum seventeen)\n\
   (fact108 isa addition-fact addend1 ten addend2 eight sum eightteen)\n\
   (fact109 isa addition-fact addend1 ten addend2 nine sum nineteen)\n\
   (nothing isa number)\n\
   (zero isa number value 0)\n\
   (one isa number value 1)\n\
   (two isa number value 2)\n\
   (three isa number value 3)\n\
   (four isa number value 4)\n\
   (five isa number value 5)\n\
   (six isa number value 6)\n\
   (seven isa number value 7)\n\
   (eight isa number value 8)\n\
   (nine isa number value 9)\n\
   (ten isa number value 10)\n\
   (eleven isa number value 11)\n\
   (twelve isa number value 12)\n\
   (thirteen isa number value 13)\n\
   (fourteen isa number value 14)\n\
   (fifteen isa number value 15)\n\
   (sixteen isa number value 16)\n\
   (seventeen isa number value 17)\n\
   (eightteen isa number value 18)\n\
   (nineteen isa number value 19)\n)\n"
    .command.frame.text insert 1.0 "(goal-focus goal)\n"

    .chunk_type.frame.text configure -state disable
    .chunk.frame.text configure -state disable
    .command.frame.text configure -state disable

    .production.frame.text insert 1.0 "(p {name}\n==>\n)\n"

    .production.frame.text tag add tutor 1.3 1.9

    .production.frame.text tag configure tutor -background black -foreground white

    set tutor_state(.production.frame.text) name

    set tutor_started(.production.frame.text) 0

    set tutor_response(.production.frame.text) "0.0"
    
    focus .production.frame.text
    
    set tutor_count 0
    set tutor_complete 1

    set tutor_answers(.production.frame.text) {{start-pair {{=goal add-pair {one1 var2} {one2 var3} {one-ans nil}}} \
                                                           {{+retrieval addition-fact {addend1 var2} {addend2 var3}} \
                                                            {=goal {one-ans waiting}}} \
                                                           {{var2} {var3}} \
                                                           {{var2 =first =one1} {var3 =second =one2}}} \
                                               {add-ones   {{=goal add-pair {one1 var2} {one2 var3} {one-ans waiting}} \
                                                            {=retrieval addition-fact {addend1 var2} {addend2 var3} {sum var4}}} \
                                                           {{+retrieval addition-fact {addend1 ten} {sum var4}} \
                                                            {=goal {one-ans var4} {carry waiting}}} \
                                                           {{var2} {var3} {var4}} \
                                                           {{var2 =first =one1 =o1} {var3 =second =one2 =o2} {var4 =sum =s =answer}}} \
                                               {process-carry {{=goal add-pair {one-ans var4} {carry waiting} {ten1 var2} {ten2 var3}} \
                                                               {=retrieval addition-fact {addend1 ten} {addend2 var6} {sum var4}}} \
                                                              {{+retrieval addition-fact {addend1 var2} {addend2 var3}} \
                                                               {=goal {one-ans var6} {carry one} {ten-ans waiting}}} \
                                                              {{var2} {var3} {var4} {var6}} \
                                                              {{var2 =first =one1 =o1 =a1} {var3 =second =one2 =o2 =a2} {var4 =one-ans =answer =oa =sum} {var6 =rest =result =remainder =rem}}} \
                                               {no-carry   {{=goal add-pair {one-ans var4} {carry waiting} {ten1 var2} {ten2 var3}} \
                                                            {=retrieval error}} \
                                                           {{+retrieval addition-fact {addend1 var2} {addend2 var3}} \
                                                            {=goal {carry nil} {ten-ans waiting}}} \
                                                           {{var2} {var3} {var4}} \
                                                           {{var2 =first =ten1 =t1} {var3 =second =ten2 =t2} {var4 =answer =one-ans =sum}}} \
                                               {add-tens-done {{=goal add-pair {ten-ans waiting} {carry nil}} \
                                                               {=retrieval addition-fact {sum var2}}} \
                                                              {{=goal {ten-ans var2}}} \
                                                              {{var2}} \
                                                              {{var2 =sum}}} \
                                               {add-tens-carry {{=goal add-pair {ten-ans waiting} {ten1 var2} {ten2 var3} {carry one}} \
                                                                {=retrieval addition-fact {addend1 var2} {addend2 var3} {sum var4}}} \
                                                               {{+retrieval addition-fact {addend1 one} {addend2 var4}} \
                                                                {=goal {carry nil}}} \
                                                               {{var2} {var3} {var4}} \
                                                               {{var2 =first =ten1 =t1} {var3 =second =ten2 =t2} {var4 =sum =s =answer}}}} 
}


proc handle_tutor_entry {win key} {
  global tutor_response
  global tutor_answers
  global tutor_answer
  global tutor_state
  global tutor_started  
  global tutor_count
  global tutor_complete

  if {$tutor_state($win) != "done"} {

  set start_char ""
  set insert_char ""

  regexp -nocase {([0-9]+)\.([0-9]+)} $tutor_response($win) dummy line start_char  
  regexp -nocase {([0-9]+)\.([0-9]+)} [$win index insert] dummy line insert_char  
  
  if {$key == "BackSpace"} {
    if {$start_char == ""} {
      set safe 0
    } elseif {$start_char < $insert_char} {
      set safe 1
    } else {
      set safe 0
    }
  } else {
    set safe 1
  }

  if {[normal_key $key] && $safe} {

    if !$tutor_started($win) {
      set tutor_started($win) 1

      set tutor_response($win) [$win index tutor.first]

      $win delete tutor.first tutor.last

      $win mark set insert $tutor_response($win)
 
    } 
  } elseif $tutor_started($win)  {  

    set done 0

    set foo $tutor_response($win)

    if {$win == ".production.frame.text"} {
      set response [$win get $tutor_response($win) [$win index "$foo lineend"]]    
    } else {
      set response [$win get $tutor_response($win) "[$win index "$foo lineend"] - 1 chars"]    
    }
 
    #if {$tutor_state($win) != "name"} {report_status "\n$tutor_state($win): $tutor_answer($win)"}

    switch $win {
      .chunk.frame.text {
        switch $tutor_state($win) {
          name {
            set found ""

            for {set i 0} {$i < [llength $tutor_answers($win)] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $tutor_answers($win) $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a required chunk." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{name})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {
              set tutor_answer($win) [lreplace [lindex $tutor_answers($win) $found] 0 0]
              
              set tutor_answers($win) [lreplace $tutor_answers($win) $found $found]

              set tutor_state($win) chunktype
              
              $win insert "$tutor_response($win) lineend - 1 chars" " ISA {chunk-type}"

              $win tag add tutor "$tutor_response($win) lineend - 13 chars" "$tutor_response($win) lineend - 1 chars"
              
              set tutor_started($win) 0

            }  
          }
          chunktype {
            if {[string compare [string tolower [lindex $tutor_answer($win) 0]] [string tolower $response]] != 0} {
            
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of the chunktype for this chunk." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{chunk-type})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 12 chars"

              set tutor_started($win) 0

            } else {
              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
              # assuming that there won't be a tutor without slots in chunks: 

              $win insert "$tutor_response($win) lineend - 1 chars" " {slot}"

              $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend - 1 chars"
              
              set tutor_state($win) slot
              set tutor_started($win) 0
            } 
          }
          slot {

            set found ""

            for {set i 0} {$i < [llength $tutor_answer($win)] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $tutor_answer($win) $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a slot for this chunk." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{slot})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {
              set temp [lindex $tutor_answer($win) $found]

              set tutor_answer($win) [lreplace $tutor_answer($win) $found $found]
              
              set tutor_answer($win) [lreplace $tutor_answer($win) 0 -1 [lindex $temp 1]]             

              $win insert "$tutor_response($win) lineend - 1 chars" " {value}"

              $win tag add tutor "$tutor_response($win) lineend - 8 chars" "$tutor_response($win) lineend - 1 chars"
              
              set tutor_state($win) value
              
              set tutor_started($win) 0
              
            } 
          }
          value {
           set found ""

             if {[string compare [string tolower [lindex $tutor_answer($win) 0]] [string tolower $response]] != 0} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the correct value for this slot of this chunk." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0

            } else {
              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
              if {$tutor_answer($win) == ""} { # this chunk is over

                if {$tutor_answers($win) == ""} { # there are no more chunktypes
                  
                  set done 1 
                  
                  $win configure -state disable
                } else {
                
                  set foo [$win index "$tutor_response($win) + 1 lines linestart"]

                  $win insert $foo "  ({name})\n"

                  $win tag add tutor "$foo + 3 chars" "$foo + 9 chars"
              
                  set tutor_state($win) name
                  set tutor_started($win) 0
                }
              } else { # more slots to add...

                set tutor_state($win) slot

                $win insert "$tutor_response($win) lineend - 1 chars" " {slot}"

                $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend - 1 chars"
              
                set tutor_started($win) 0
              }
            } 
          }
        }
      }
      .chunk_type.frame.text {
        switch $tutor_state($win) {
          name {
            set found ""

            for {set i 0} {$i < [llength $tutor_answers($win)] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $tutor_answers($win) $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a required chunktype." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{name})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0
               
              

            } else {
              set tutor_answer($win) [lreplace [lindex $tutor_answers($win) $found] 0 0]
              
              set tutor_answers($win) [lreplace $tutor_answers($win) $found $found]

              set tutor_state($win) slot
              
              $win insert "$tutor_response($win) lineend - 1 chars" " {slot}"

              $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend - 1 chars"
              
              set tutor_started($win) 0

            }  
          }
          slot {
            set found ""

            for {set i 0} {$i < [llength $tutor_answer($win)] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex $tutor_answer($win) $i]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a slot for this chunktype." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{slot})"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {
              set tutor_answer($win) [lreplace $tutor_answer($win) $found $found]
              
              if {$tutor_answer($win) == ""} { # this chunktype is over

                if {$tutor_answers($win) == ""} { # there are no more chunktypes
                  
                  set done 1 
                  
                  $win configure -state disable
                } else {
                
                  set foo [$win index "$tutor_response($win) + 1 lines linestart"]

                  $win insert $foo "(chunk-type {name})\n"

                  $win tag add tutor "$foo + 12 chars" "$foo + 18 chars"
              
                  set tutor_state($win) name
                  set tutor_started($win) 0
                }
              } else { # more slots to add...

                $win insert "$tutor_response($win) lineend - 1 chars" " {slot}"

                $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend - 1 chars"
              
                set tutor_started($win) 0
              }
            } 
          }
        }
      }
      .production.frame.text {
        switch $tutor_state($win) {
          name {
           set found ""

            for {set i 0} {$i < [llength $tutor_answers($win)] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $tutor_answers($win) $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a required production." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{name}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {
              set tutor_answer($win) [lreplace [lindex $tutor_answers($win) $found] 0 0]
              
              set tutor_answers($win) [lreplace $tutor_answers($win) $found $found]

              set tutor_state($win) condition
              
              $win insert "$tutor_response($win) lineend" "\n  {condition}"

              $win tag add tutor "$tutor_response($win) + 1 lines lineend - 11 chars" "$tutor_response($win) + 1 lines lineend"
              
              set tutor_started($win) 0
            }
          }
          condition {
            set found ""
            set conditions [lindex $tutor_answer($win) 0]

            for {set i 0} {$i < [llength $conditions] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $conditions $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a buffer to test in this production." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{condition}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 11 chars"

              set tutor_started($win) 0

            } else {

              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace $conditions $found $found]]
              
              set tutor_answer($win) [lreplace $tutor_answer($win) 0 -1 [lreplace [lindex $conditions $found] 0 0]]

              set tutor_state($win) condition_type
              
              $win insert "$tutor_response($win) lineend" ">\n    ISA {chunk-type}"

              $win tag add tutor "$tutor_response($win) + 1 lines lineend - 12 chars" "$tutor_response($win) + 1 lines lineend"
              
              set tutor_started($win) 0

             }
      
          }
          condition_type {

            if {[string compare [string tolower [lindex [lindex $tutor_answer($win) 0] 0]] [string tolower $response]] != 0} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the correct chunk-type for this buffer test." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{chunk-type}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 12 chars"

              set tutor_started($win) 0

            } else {
              set current_condition [lreplace [lindex $tutor_answer($win) 0] 0 0]

              if {$current_condition == ""} { # this condition is complete

                if {[lindex $tutor_answer($win) 1] == ""} { # there are no more conditions
                  
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 1]
                  set tutor_state($win) action

                  $win insert "$tutor_response($win) linestart + 2 lines" "  {action}\n"
 
                  $win tag add tutor "$tutor_response($win) linestart + 2 lines + 2 chars" "$tutor_response($win) linestart + 2 lines + 10 chars"
              
                  set tutor_started($win) 0

                } else { # add more conditions
             
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
                  set tutor_state($win) condition
              
                  $win insert "$tutor_response($win) lineend" "\n  {condition}"

                  $win tag add tutor "$tutor_response($win) + 1 lines lineend - 11 chars" "$tutor_response($win) + 1 lines lineend"
              
                  set tutor_started($win) 0
                }
              } else { # slots to test on this condition

                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 $current_condition]
              
                set tutor_state($win) condition_slot

                $win insert "$tutor_response($win) lineend" "\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines lineend - 6 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            } 
          }
          condition_slot {
             
            set slots [lindex $tutor_answer($win) 0]
            set found ""

            for {set i 0} {$i < [llength $slots] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $slots $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a slot to test in this condition." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{slot}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {

              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace [lreplace $slots $found $found] 0 -1 [lindex [lindex $slots $found] 1]]]
              
              $win insert "$tutor_response($win) lineend" " {value}"

              $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend"
              
              set tutor_started($win) 0

              set val [lindex [lindex $tutor_answer($win) 0] 0]
              set vars [lindex $tutor_answer($win) 3]

              set found ""

              for {set i 0} {$i < [llength $vars] && $found == ""} {incr i} {
                if {[string compare [string tolower $val] [string tolower [lindex [lindex $vars $i] 0]]] == 0} {
                  set found $i
                }
              }

              if {$found == ""} {
                set tutor_state($win) condition_value
              } elseif {[llength [lindex $vars $found]] == 2} {
                set tutor_state($win) condition_value
                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace [lindex $tutor_answer($win) 0] 0 0 [lindex [lindex $vars $found] 1]]]
              } else {
                set tutor_state($win) condition_var_unbound
              }
            }
          }
          condition_value {
            
            if {[string compare [string tolower [lindex [lindex $tutor_answer($win) 0] 0]] [string tolower $response]] != 0} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                          -message "$response is not the correct value for this slot of this condition." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0

            } else {
              set temp [lreplace [lindex $tutor_answer($win) 0] 0 0]
              
              if {$temp == ""} { # this condition is over

                if {[lindex $tutor_answer($win) 1] == ""} { # there are no more conditions
                  
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 1]
                  set tutor_state($win) action

                  $win insert "$tutor_response($win) linestart + 2 lines" "  {action}\n"
 
                  $win tag add tutor "$tutor_response($win) linestart + 2 lines + 2 chars" "$tutor_response($win) linestart + 2 lines + 10 chars"
              
                  set tutor_started($win) 0

                } else { # add more conditions
             
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
                  set tutor_state($win) condition
              
                  $win insert "$tutor_response($win) lineend" "\n  {condition}"

                  $win tag add tutor "$tutor_response($win) + 1 lines lineend - 11 chars" "$tutor_response($win) + 1 lines lineend"
              
                  set tutor_started($win) 0
                }
             
              } else { # more slots to add to the current condition

                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 $temp]

                set tutor_state($win) condition_slot

                $win insert "$tutor_response($win) lineend" "\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines linestart + 4 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            } 
          }
          condition_var_unbound {
            
            if {[string index $response 0] != "="} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                          -message "This slot requires a variable and variables must start with an '='." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0

            } elseif {[lsearch -exact "=goal =retrieval =visual =visual-location =visual-state =manual =manual-state =vocal =vocal-state =aural =aural-location =aural-state" [string tolower $response]] != -1 } {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                          -message "That variable is the name of a buffer and this slot requires a new variable name." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0
            } else {
             
              set bindings ""
              foreach {x} [lindex $tutor_answer($win) 3] {
                set bindings [lreplace $bindings 0 -1 [string tolower [lindex $x 1]]]
              }

              if {[lsearch -exact $bindings [string tolower $response]] != -1 } {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                          -message "That variable name has already been used and this slot requires a new variable name." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0
             } else {
              # save this binding for later use...

              set var [lindex [lindex $tutor_answer($win) 0] 0]

              set bindings [lindex $tutor_answer($win) 3]

              set index [lsearch -exact $bindings $var]

              set bindings [lreplace $bindings $index $index [list $var $response]]

              set tutor_answer($win) [lreplace $tutor_answer($win) 3 3 $bindings]

              set temp [lreplace [lindex $tutor_answer($win) 0] 0 0]
              
              if {$temp == ""} { # this condition is over

                if {[lindex $tutor_answer($win) 1] == ""} { # there are no more conditions
                  
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 1]
                  set tutor_state($win) action

                  $win insert "$tutor_response($win) linestart + 2 lines" "  {action}\n"
 
                  $win tag add tutor "$tutor_response($win) linestart + 2 lines + 2 chars" "$tutor_response($win) linestart + 2 lines + 10 chars"
              
                  set tutor_started($win) 0

                } else { # add more conditions
             
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
                  set tutor_state($win) condition
              
                  $win insert "$tutor_response($win) lineend" "\n  {condition}"

                  $win tag add tutor "$tutor_response($win) + 1 lines lineend - 11 chars" "$tutor_response($win) + 1 lines lineend"
              
                  set tutor_started($win) 0
                }
             
              } else { # more slots to add to the current condition

                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 $temp]

                set tutor_state($win) condition_slot

                $win insert "$tutor_response($win) lineend" "\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines linestart + 4 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            }
            } 
          }
          action {

            set found ""
            set actions [lindex $tutor_answer($win) 0]

            for {set i 0} {$i < [llength $actions] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $actions $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not one of the required actions in this production." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{action}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 8 chars"

              set tutor_started($win) 0

            } else {

              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace $actions $found $found]]
              
              set tutor_answer($win) [lreplace $tutor_answer($win) 0 -1 [lreplace [lindex $actions $found] 0 0]]


    
              # +retrieval requires an ISA...
              
              if {[string tolower $response] == "+retrieval"} {

                set tutor_state($win) action_type
              
                $win insert "$tutor_response($win) lineend" ">\n    ISA {chunk-type}"

                $win tag add tutor "$tutor_response($win) + 1 lines lineend - 12 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              } else {
                set tutor_state($win) action_slot
              
                $win insert "$tutor_response($win) lineend" ">\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines lineend - 6 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            }
          }
          action_type {
            if {[string compare [string tolower [lindex [lindex $tutor_answer($win) 0] 0]] [string tolower $response]] != 0} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the correct chunk-type for this buffer request." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{chunk-type}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 12 chars"

              set tutor_started($win) 0

            } else {
              set current_action [lreplace [lindex $tutor_answer($win) 0] 0 0]

              if {$current_action == ""} { # this action is complete

                if {[lindex $tutor_answer($win) 1] == ""} { # there are no more actions
                  
                  if {$tutor_answers($win) == ""} { # there are no more productions
                  
                    set done 1 
                  
                    $win configure -state disable
                  } else {
                
                    set foo [$win index "$tutor_response($win) + 2 lines linestart"]

                    $win insert $foo "(p {name}\n==>\n)\n"

                    $win tag add tutor "$foo + 3 chars" "$foo + 9 chars"
              
                    set tutor_state($win) name
                    set tutor_started($win) 0
                  }
              
                } else { # add more actions
             
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
                  set tutor_state($win) action
              
                  $win insert "$tutor_response($win) lineend" "\n  {action}"

                  $win tag add tutor "$tutor_response($win) + 1 lines lineend - 8 chars" "$tutor_response($win) + 1 lines lineend"
              
                  set tutor_started($win) 0
                }
              } else { # slots to test on this action

                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 $current_action]
              
                set tutor_state($win) action_slot

                $win insert "$tutor_response($win) lineend" "\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines lineend - 6 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            } 
          }
          action_slot {
   
            set slots [lindex $tutor_answer($win) 0]
            set found ""

            for {set i 0} {$i < [llength $slots] && $found == ""} {incr i} {
              if {[string compare [string tolower [lindex [lindex $slots $i] 0]] [string tolower $response]] == 0} {
                set found $i
              }
            }

            if {$found == ""} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                            -message "$response is not the name of a slot required in this action." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{slot}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 6 chars"

              set tutor_started($win) 0

            } else {

              set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace [lreplace $slots $found $found] 0 -1 [lindex [lindex $slots $found] 1]]]
              

              set val [lindex [lindex $tutor_answer($win) 0] 0]
              set vars [lindex $tutor_answer($win) 2]

              set found ""

              for {set i 0} {$i < [llength $vars] && $found == ""} {incr i} {
                if {[string compare [string tolower $val] [string tolower [lindex [lindex $vars $i] 0]]] == 0} {
                  set found $i
                }
              }

              if {$found != ""} {
                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 [lreplace [lindex $tutor_answer($win) 0] 0 0 [lindex [lindex $vars $found] 1]]]
              }

              $win insert "$tutor_response($win) lineend" " {value}"

              $win tag add tutor "$tutor_response($win) lineend - 7 chars" "$tutor_response($win) lineend"
              
              set tutor_started($win) 0

              set tutor_state($win) action_value
            }
          }
          action_value {

            
            if {[string compare [string tolower [lindex [lindex $tutor_answer($win) 0] 0]] [string tolower $response]] != 0} {
              tk_messageBox -icon warning -type ok -title "Tutor" \
                          -message "$response is not the correct value for this slot of this action." 

              focus $win 

              $win delete $tutor_response($win) "$tutor_response($win) lineend"
             
              $win insert $tutor_response($win) "{value}"

              $win tag add tutor $tutor_response($win) "$tutor_response($win) + 7 chars"

              set tutor_started($win) 0

            } else {
              set temp [lreplace [lindex $tutor_answer($win) 0] 0 0]
              
              if {$temp == ""} { # this action is over

                if {[lindex $tutor_answer($win) 1] == ""} { # there are no more actions
                  
                  if {$tutor_answers($win) == ""} { # there are no more chunktypes
                  
                    set done 1 
                  
                    $win configure -state disable
                  } else {
                
                    set foo [$win index "$tutor_response($win) + 2 lines linestart"]

                    $win insert $foo "(p {name}\n==>\n)\n"

                    $win tag add tutor "$foo + 3 chars" "$foo + 9 chars"
              
                    set tutor_state($win) name
                    set tutor_started($win) 0
                  }
                } else { # add more actions
             
                  set tutor_answer($win) [lreplace $tutor_answer($win) 0 0]
              
                  set tutor_state($win) action
              
                  $win insert "$tutor_response($win) lineend" "\n  {action}"

                  $win tag add tutor "$tutor_response($win) + 1 lines lineend - 8 chars" "$tutor_response($win) + 1 lines lineend"
              
                  set tutor_started($win) 0
                }
             
              } else { # more slots to add to the current action

                set tutor_answer($win) [lreplace $tutor_answer($win) 0 0 $temp]

                set tutor_state($win) action_slot

                $win insert "$tutor_response($win) lineend" "\n    {slot}"

                $win tag add tutor "$tutor_response($win) + 1 lines linestart + 4 chars" "$tutor_response($win) + 1 lines lineend"
              
                set tutor_started($win) 0
              }
            } 
          }
        }
      }
    }

    set tutor_response($win) ""

    if $done {
      incr tutor_count
 
      set tutor_state($win) done

      if {$tutor_count == $tutor_complete} {
          tk_messageBox -icon info -type ok -title "Tutor Complete" \
                            -message "You have completed this tutor exercise.\nTo continue with this model you should\
close it and then reopen it as an existing model." 
      }
    } else {
      $win configure -state disable
  
      after 200 "$win configure -state normal"
    }
  } else {
    $win configure -state disable
  
    after 200 "$win configure -state normal"
  }   
}
}

proc report_tutor_help {win} {
  global tutor_response
  global tutor_answers
  global tutor_answer
  global tutor_state

    $win configure -state disable

  if {$tutor_state($win) != "done"} {
    set text [switch $win {
      .chunk.frame.text {
        switch $tutor_state($win) {
          name {
            format "[string tolower [lindex [lindex $tutor_answers($win) 0] 0]] is the name of a required chunk."
          }
          chunktype {
            format "[string tolower [lindex $tutor_answer($win) 0]] is the chunk-type for this chunk."
          }
          slot {

            format "[string tolower [lindex [lindex $tutor_answer($win) 0] 0]] is the name of one of the slots to set for this chunk."
          }
          value {
            format "[string tolower [lindex $tutor_answer($win) 0]] is the value for this slot in this chunk."
          }
        }
      }
      .chunk_type.frame.text {
        switch $tutor_state($win) {
          name {
            format "[string tolower [lindex [lindex $tutor_answers($win) 0] 0]] is the name of one of the required chunk-types." 
          }
          slot {
            format "[string tolower [lindex $tutor_answer($win) 0]] is one of the slots in this chunk-type."
          }
        }
      }
      .production.frame.text {
        switch $tutor_state($win) {
          name {
            format "[string tolower [lindex [lindex $tutor_answers($win) 0] 0]] is the name of one of the required productions." 
          }
          condition {
            format "[string tolower [lindex [lindex [lindex $tutor_answer($win) 0] 0] 0]] is one of the buffers to test." 
          }
          condition_type {
            format "[string tolower [lindex [lindex $tutor_answer($win) 0] 0]] is the chunk-type for this buffer test." 
          }
          condition_slot {
            format "[string tolower [lindex [lindex [lindex $tutor_answer($win) 0] 0] 0]] is one of the slots to test." 
          }
          condition_value {
            format "[string tolower [lindex [lindex $tutor_answer($win) 0] 0]] is the value for this slot test." 
          }
          condition_var_unbound {
         
            set var [lindex [lindex $tutor_answer($win) 0] 0]

            set bindings ""
       
            foreach {x} [lindex $tutor_answer($win) 3] {
              set bindings [lreplace $bindings 0 -1 [string tolower [lindex $x 1]]]
            }

            foreach {x} [lindex $tutor_answer($win) 4] {
              if {$var == [lindex $x 0]} {
                set possibles [lreplace $x 0 0]
              }
            }

            foreach {x} $bindings {
              if {[lsearch -exact $possibles $x] != -1} {
                set possibles [lreplace $possibles [lsearch -exact $possibles $x] [lsearch -exact $possibles $x]]
              }
            }
         
            format "This slot requires a new variable name.  [string tolower [lindex $possibles 0]] is one such name that could be used." 
          }
          action {
            format "[string tolower [lindex [lindex [lindex $tutor_answer($win) 0] 0] 0]] is one of the actions for this production." 
          }
          action_type {
            format "[string tolower [lindex [lindex $tutor_answer($win) 0] 0]] is the chunk-type for this action." 
          }
          action_slot {
            format "[string tolower [lindex [lindex [lindex $tutor_answer($win) 0] 0] 0]] is one of the slots for this action." 
          }
          action_value {
            format "[string tolower [lindex [lindex $tutor_answer($win) 0] 0]] is the required value." 
          }
        }
      }
    }]

    tk_messageBox -icon info -type ok -title "Tutor Help" -message $text

    focus $win
   after 200 "$win configure -state normal"
  
 }
}


proc normal_key {key} {
  return [regexp {^([a-zA-Z0-9]|underscore|minus|plus|equal|BackSpace|Shift_L|Shift_R)$} $key]
}


