global wait_for_create
global stop_type
global stepper_tutor
global stepper_waiter
global stepper_temp
global instan_view
global instan_parsed
global tutor_temp
global tutor_ans
global tutor_bindings
global initial_wait


proc select_stepper {} {
  global wait_for_create
  global stop_type
  global instan_parsed
  global tutor_temp
  global options_array
  global initial_wait

  if {[winfo exists .stepper] == 1} {
    wm deiconify .stepper
    raise .stepper
  } else {
    # make it now

    toplevel .stepper
    wm withdraw .stepper
    wm title .stepper "Stepper"

    wm geometry .stepper [get_configuration .stepper]


    send_environment_cmd \
      "create simple-handler .stepper stepper_temp \
         (lambda (x) nil) ()"

    bind .stepper <Destroy> {
      remove_handler .stepper
    }


    button .stepper.step -text "Step" -font button_font -command {
      global stepper_tutor
      global step_return
      global tutor_bindings


        if {!$stepper_tutor || [array names tutor_bindings] == ""} { 
          send_environment_cmd "update [get_handler_name .stepper.step]"

          set instan_parsed 0
        } else {
           tk_messageBox -icon info -type ok -title "Tutoring" \
                    -message "You must complete the instantiation before continuing in tutor mode."
        }
    }

    send_environment_cmd \
      "create simple-handler .stepper.step ignore_returns \
         (lambda (x) (setf *stepper-advance* $options_array(stepper_mode))) ()"

    bind .stepper.step <Destroy> {
      remove_handler .stepper.step
    }
 
    button .stepper.stop -text "Stop After" -font button_font -command {
      global stepper_tutor

      if $stepper_tutor {
        tk_messageBox -icon info -type ok -title "Tutoring" \
                    -message "Only the Step button can be used when in tutor mode."
      } else {
        send_environment_cmd "update [get_handler_name .stepper.stop]"
      }
    }
  
    send_environment_cmd \
      "create simple-handler .stepper.stop ignore_returns \
         (lambda (x) (setf *stepper-advance* :stop)) ()"

    bind .stepper.stop <Destroy> {
      remove_handler .stepper.stop
    }



    tk_optionMenu .stepper.run_until_type stop_type Time Production 
    .stepper.run_until_type configure -font menu_font


    button .stepper.run_until -text "Run Until-" -font button_font \
           -command {
       global stepper_tutor

      if $stepper_tutor {
       tk_messageBox -icon info -type ok -title "Tutoring" \
                    -message "Only the Step button can be used when in tutor mode."
      } else {
        send_environment_cmd "update [get_handler_name .stepper.run_until] \
         (lambda (x) \
          (schedule-stepper-skip-time '($stop_type $run_until_time)) \
          (setf *last-stepper-instantiation* nil)
          (setf *stepper-advance* :step))"
      }
    }                    

    send_environment_cmd \
      "create simple-handler .stepper.run_until ignore_returns \
       (lambda (x) (setf *stepper-skip-until-time* nil)) ()"

    bind .stepper.run_until <Destroy> {
      remove_handler .stepper.run_until
    }


    entry .stepper.run_until_time -width 6 -font text_font \
      -textvariable run_until_time -justify right


    label .stepper.current -text "Next Event" -justify left -font label_font

    set initial_wait ""

    send_environment_cmd \
      "create simple-handler .stepper.current initial_wait \
         (lambda (x) \
            (setf *stepper-active* t) \
            (setf *stepper-advance* nil) \
            (stepper-control-function x)) \
         (pre instan post step)"

    bind .stepper.current <Destroy> {
      remove_handler .stepper.current \
            "(lambda () \
                 (setf *stepper-active* nil) \
                 (setf *stepper-skip-until-time* nil) \
                 (setf *stepper-advance* :step))"

    }

    wait_for_non_null initial_wait

    frame .stepper.current_frame -borderwidth 1  
    
    text .stepper.current_frame.text -font text_font -state disabled \
         -yscrollcommand ".stepper.current_frame.scrl set"           

    send_environment_cmd \
      "create text-output-handler .stepper.current_frame.text \
         .stepper.current_frame.text stepper-cur-event nil"

    bind .stepper.current_frame.text <Destroy> {
      remove_handler .stepper.current_frame.text
    }

    scrollbar .stepper.current_frame.scrl \
              -command ".stepper.current_frame.text yview"
    
    label .stepper.event -text "Show Events" -justify left -font label_font
 
    frame .stepper.events -borderwidth 2 -relief groove  
     
    checkbutton .stepper.events.cognitive -text "Production" \
                -font checkbox_font -variable s1 \
                -command {update_stepper_events $s1 :production}\
                -onvalue t -offvalue nil

    checkbutton .stepper.events.memory -text "Retrieval" \
                -font checkbox_font -variable s2 \
                -command {update_stepper_events $s2 :retrieval} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.visual -text "Visual" \
                -font checkbox_font -variable s3 \
                -command {update_stepper_events $s3 :vision} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.aural -text "Aural" \
                -font checkbox_font -variable s4 \
                -command {update_stepper_events $s4 :audio} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.manual -text "Manual"  \
                -font checkbox_font -variable s5 \
                -command {update_stepper_events $s5 :motor} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.vocal -text "Vocal"  \
                -font checkbox_font -variable s6 \
                -command {update_stepper_events $s6 :speech} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.external -text "External" \
                -font checkbox_font -variable s7 \
                -command {update_stepper_events $s7 :external} \
                -onvalue t -offvalue nil

    checkbutton .stepper.events.device -text "Device" \
                -font checkbox_font -variable s8 \
                -command {update_stepper_events $s8 :device} \
                -onvalue t -offvalue nil
 
    set wait_for_create ""

    send_environment_cmd \
      "create simple-handler .stepper.events wait_for_create (lambda (x)) ()"

    bind .stepper.events <Destroy> {
      remove_handler .stepper.events
    }
    
    label .stepper.instan -textvar .stepper.instan.var \
                          -justify left -font label_font

    send_environment_cmd \
      "create simple-handler .stepper.instan .stepper.instan.var \
         stepper-list-name nil"

    bind .stepper.instan <Destroy> {
      remove_handler .stepper.instan
    }


    checkbutton .stepper.stepper_tutor -text "Tutor Mode" -font checkbox_font \
                -variable stepper_tutor \
                -command {global stepper_waiter
                          global tutor_bindings

                           set stepper_waiter ""
                          
                           send_environment_cmd \
                             "update [get_handler_name .stepper.stepper_tutor] \
                             (lambda (x) \
                                (if (= $stepper_tutor 1) \
                                   (progn \
                                      (setf *tutor-mode* t) \
                                      (setf *tutor-bindings* nil) \
                                      (setf *tutor-responses* nil)) \
                                    (setf *tutor-mode* nil)))"

                               set instan_parsed 0

                               if [array exists tutor_bindings] {
                                   array unset tutor_bindings 
                               }  

                               wait_for_non_null stepper_waiter
                               update_instantiation_viewers .stepper.productions.list
                                
    }
    
    .stepper.stepper_tutor deselect
    set instan_parsed 0

    send_environment_cmd \
      "create simple-handler .stepper.stepper_tutor stepper_waiter \
         (lambda (x) (setf *tutor-mode* nil)) nil"

     bind .stepper.stepper_tutor <Destroy> {
      remove_handler .stepper.stepper_tutor
     }

    frame .stepper.prod_frame -borderwidth 0
 
    frame .stepper.prod_frame.f1 -borderwidth 0

    label .stepper.prod_frame.f1.info \
          -textvariable .stepper.prod_frame.f1.info.var \
          -justify left -font label_font

    send_environment_cmd \
      "create simple-handler .stepper.prod_frame.f1.info \
              .stepper.prod_frame.f1.info.var \
              stepper-details-name nil"

    bind .stepper.prod_frame.f1.info <Destroy> {
      remove_handler .stepper.prod_frame.f1.info
    }

    frame .stepper.prod_frame.f1.info_frame -borderwidth 1  
    
    text .stepper.prod_frame.f1.info_frame.text -font text_font \
         -yscrollcommand ".stepper.prod_frame.f1.info_frame.scrl set" \
         -state disabled
          
    scrollbar .stepper.prod_frame.f1.info_frame.scrl \
              -command ".stepper.prod_frame.f1.info_frame.text yview"

    send_environment_cmd \
      "create text-output-handler .stepper.prod_frame.f1.info_frame.text \
         .stepper.prod_frame.f1.info_frame.text (lambda (x) ) nil"

    bind .stepper.prod_frame.f1.info_frame.text <Destroy> {
      remove_handler .stepper.prod_frame.f1.info_frame.text
    }
  
    frame .stepper.prod_frame.f2 -borderwidth 0

    label .stepper.prod_frame.f2.bindings \
          -textvariable .stepper.prod_frame.f2.bindings.var \
          -justify left -font label_font

     send_environment_cmd \
      "create simple-handler .stepper.prod_frame.f2.bindings \
              .stepper.prod_frame.f2.bindings.var \
              stepper-bindings-name nil"

     bind .stepper.prod_frame.f2.bindings <Destroy> {
      remove_handler .stepper.prod_frame.f2.bindings
     }

    frame .stepper.prod_frame.f2.bindings_frame -borderwidth 1  
    
    text .stepper.prod_frame.f2.bindings_frame.text -font text_font \
         -yscrollcommand ".stepper.prod_frame.f2.bindings_frame.scrl set" \
         -state disabled

    send_environment_cmd \
      "create text-output-handler .stepper.prod_frame.f2.bindings_frame.text \
        .stepper.prod_frame.f2.bindings_frame.text (lambda (x) ) nil"

    bind .stepper.prod_frame.f2.bindings_frame.text <Destroy> {
      remove_handler .stepper.prod_frame.f2.bindings_frame.text
    }

    scrollbar .stepper.prod_frame.f2.bindings_frame.scrl \
              -command ".stepper.prod_frame.f2.bindings_frame.text yview"

    frame .stepper.prod_frame.f3 -borderwidth 0

    label .stepper.prod_frame.f3.production \
          -textvariable .stepper.prod_frame.f3.production.var  \
          -justify left -font label_font

     send_environment_cmd \
      "create simple-handler .stepper.prod_frame.f3.production \
              .stepper.prod_frame.f3.production.var \
              stepper-prod_frame-name nil"

     bind .stepper.prod_frame.f3.production <Destroy> {
      remove_handler .stepper.prod_frame.f3.production
     }

    frame .stepper.prod_frame.f3.production_frame -borderwidth 1  
    
    text .stepper.prod_frame.f3.production_frame.text -font text_font \
         -yscrollcommand ".stepper.prod_frame.f3.production_frame.scrl set" \
         -state disabled 

    send_environment_cmd \
      "create special-simple-output-handler .stepper.prod_frame.f3.production_frame.text \
         instan_view (lambda (x)) nil"

    send_environment_cmd \
      "create simple-handler .tutor tutor_temp (lambda (x)) nil"

    bind .stepper.prod_frame.f3.production_frame.text <Destroy> {
      remove_handler .stepper.prod_frame.f3.production_frame.text
      remove_handler .tutor
    }

    scrollbar .stepper.prod_frame.f3.production_frame.scrl \
              -command ".stepper.prod_frame.f3.production_frame.text yview"

    frame .stepper.productions -borderwidth 0  
  
    listbox .stepper.productions.list -listvar .stepper.productions.list.var \
            -yscrollcommand ".stepper.productions.scrl set" \
            -selectmode single -exportselection 0 -font list_font
     
    send_environment_cmd \
      "create select-first-list-box-handler .stepper.productions.list \
        .stepper.productions.list stepper-instan-list nil"

    bind .stepper.productions.list <Destroy> {
      remove_handler .stepper.productions.list
    }
   
    bind .stepper.productions.list <<ListboxSelect>> {
      update_instantiation_viewers %W
    }

    scrollbar .stepper.productions.scrl \
              -command ".stepper.productions.list yview"

    place .stepper.step -x 2 -y 5 -width 70 -height 25
    place .stepper.stop -x 75 -y 5 -width 70 -height 25
    place .stepper.run_until -x 148 -y 5 -width 70 -height 25
    place .stepper.run_until_type -x 221 -y 5 -width 100 -height 25
    place .stepper.run_until_time -x 324 -y 5 -width 70 -height 25
    place .stepper.stepper_tutor -x 398 -y 5 -height 25 -width 100

    place .stepper.current -x 0 -y 30 -height 25 -relwidth .4 
 
    place .stepper.current_frame -x 0 -y 60 -relwidth .4 -relheight .3 \
                                 -height -60 
  
    place .stepper.event -x 0 -rely 1.0 -y -150 -height 20 -relwidth .4

    place .stepper.events -x 0 -rely 1.0 -y -125 -relwidth .4 -height 125 
  
    place .stepper.instan -x 0 -rely .3 -height 25 -relwidth .4

    place .stepper.productions -x 0 -rely .3 -y 30 -relwidth .4 -relheight .7 \
                               -height -155
  
    place .stepper.prod_frame -relx .4 -y 30 -relwidth .6 -relheight 1.0 \
                              -height -30

    place .stepper.prod_frame.f1 -relx 0.0 -rely 0.0 \
                                 -relwidth 1.0 -relheight 0.15
    place .stepper.prod_frame.f2 -relx 0.0 -rely 0.15 \
                                 -relwidth 1.0 -relheight 0.3
    place .stepper.prod_frame.f3 -relx 0.0 -rely 0.45 \
                                 -relwidth 1.0 -relheight 0.55
  
    place .stepper.prod_frame.f1.info -x 0 -y 2 -relwidth 1.0 -height 20

    place .stepper.prod_frame.f1.info_frame -x 0 -y 25 -relwidth 1.0 \
                                            -relheight 1.0 -height -25

    place .stepper.prod_frame.f2.bindings -x 0 -y 2 -relwidth 1.0 -height 20
    place .stepper.prod_frame.f2.bindings_frame -x 0 -y 25 -relwidth 1.0 \
                                                -relheight 1.0 -height -25

    place .stepper.prod_frame.f3.production -x 0 -y 2 -relwidth 1.0 -height 20
    place .stepper.prod_frame.f3.production_frame -x 0 -y 25 -relwidth 1.0 \
                                                  -relheight 1.0 -height -25

    pack .stepper.current_frame.scrl -side right -fill y 
    pack .stepper.current_frame.text -side left -expand 1 -fill both

    grid columnconfigure .stepper.events {0 1} -minsize 95
    grid .stepper.events.cognitive  .stepper.events.memory -sticky ew
    grid .stepper.events.visual .stepper.events.aural -sticky ew
    grid .stepper.events.manual .stepper.events.vocal -sticky ew
    grid .stepper.events.external .stepper.events.device -sticky ew

    pack .stepper.productions.scrl -side right -fill y 
    pack .stepper.productions.list -side left -expand 1 -fill both

    pack .stepper.prod_frame.f1.info_frame.scrl -side right -fill y 
    pack .stepper.prod_frame.f1.info_frame.text -side left -expand 1 -fill both

    pack .stepper.prod_frame.f2.bindings_frame.scrl -side right -fill y 
    pack .stepper.prod_frame.f2.bindings_frame.text -side left -expand 1 \
                                                    -fill both

    pack .stepper.prod_frame.f3.production_frame.scrl -side right -fill y 
    pack .stepper.prod_frame.f3.production_frame.text -side left -expand 1 \
                                                      -fill both

    wait_for_non_null wait_for_create

    # make sure they're all off

    .stepper.events.cognitive deselect 
    .stepper.events.memory deselect
    .stepper.events.visual deselect
    .stepper.events.aural deselect
    .stepper.events.manual deselect
    .stepper.events.vocal deselect
    .stepper.events.external deselect
    .stepper.events.device deselect

    # so that when they're invoked they turn on - otherwise it seems
    # to maintain state across calls to open the window
 
    .stepper.events.cognitive invoke 
    .stepper.events.memory invoke
    .stepper.events.visual invoke
    .stepper.events.aural invoke
    .stepper.events.manual invoke
    .stepper.events.vocal invoke
    .stepper.events.external invoke
    .stepper.events.device invoke

    # now show the window 

    wm deiconify .stepper
    
  }
}

proc update_stepper_events {state event} {
  send_environment_cmd \
    "update [get_handler_name .stepper.events] \
        (lambda (x) \
            (setf (gethash  $event *stepper-events*) $state))"
}

proc update_instantiation_viewers {list} {
  global instan_view
  global stepper_tutor
  global instan_parsed
  global stepper_temp
  global tutor_temp
  global tutor_bindings

  if {[$list curselection] != ""} {
    set prod [$list get [$list curselection]]

    send_environment_cmd \
      "update [get_handler_name .stepper.prod_frame.f1.info_frame.text ] \
        (lambda (x) (stepper-instan-info '$prod ))"

    send_environment_cmd \
      "update [get_handler_name .stepper.prod_frame.f2.bindings_frame.text ] \
        (lambda (x) (stepper-instan-binding '$prod ))"

    if {!$stepper_tutor || !$instan_parsed} {
 
      set instan_view ""

      send_environment_cmd \
        "update [get_handler_name .stepper.prod_frame.f3.production_frame.text] \
          (lambda (x) (stepper-instan-production '$prod ))"

      wait_for_non_null instan_view

      .stepper.prod_frame.f3.production_frame.text configure -state normal
      .stepper.prod_frame.f3.production_frame.text delete 1.0 end

      if {$instan_view != "EMPTY_ENV_STRING"} {
        .stepper.prod_frame.f3.production_frame.text insert 1.0 $instan_view

        if $stepper_tutor {
          set tutor_temp ""

          send_environment_cmd "update [get_handler_name .tutor] \
            (lambda (x) (tutored-step))"

          wait_for_non_null tutor_temp

          if {$tutor_temp != "nil" && !$instan_parsed} {
       
            set instan_parsed 1
    
            set strt 1.0
            set side lhs
            set buf ""

            while {[set indx [.stepper.prod_frame.f3.production_frame.text search "=" $strt end]] != ""} { 

              set word_end [.stepper.prod_frame.f3.production_frame.text index "$indx + 1 chars wordend"]
              set var [.stepper.prod_frame.f3.production_frame.text get $indx $word_end]

              if {$var == "=="} {
                set side rhs
              } else {
                if {[string compare -nocase $var "=goal"] == 0} {
                  set buf "=goal"
                } elseif {[string compare -nocase $var "=retrieval"] == 0} {
                  set buf "=retrieval"
                }
            
                set t_name [new_variable_name tag]

                .stepper.prod_frame.f3.production_frame.text tag add $t_name $indx $word_end

                .stepper.prod_frame.f3.production_frame.text tag configure $t_name -background black -foreground white 
          
                set tutor_bindings($t_name) [list $indx $word_end $var $side $buf]

                .stepper.prod_frame.f3.production_frame.text tag bind $t_name <1> {
                  global tutor_bindings
                  global tutor_ans

                  set t_name [%W tag names @%x,%y]

                  set strt [lindex $tutor_bindings($t_name) 0]
                  set w_end [lindex $tutor_bindings($t_name) 1]
                  set var [lindex $tutor_bindings($t_name) 2]
                  set side [lindex $tutor_bindings($t_name) 3]
                  set buf [lindex $tutor_bindings($t_name) 4]
  
                  if {[get_tutor_response $var $side $buf]} {
               
                    wait_for_non_null tutor_ans
                
                    if {$tutor_ans != "NoAnswer"} {

                      array unset tutor_bindings $t_name

                      .stepper.prod_frame.f3.production_frame.text configure -state normal
                      .stepper.prod_frame.f3.production_frame.text delete $strt $w_end
                      .stepper.prod_frame.f3.production_frame.text tag delete $t_name
                      .stepper.prod_frame.f3.production_frame.text insert $strt $tutor_ans
                      .stepper.prod_frame.f3.production_frame.text configure -state disabled
                    }
                  }
                }
              }
            
              set strt $word_end
            }
          }
        }
      } 

      .stepper.prod_frame.f3.production_frame.text configure -state disabled
    }

  } else {
    .stepper.prod_frame.f1.info_frame.text configure -state normal
    .stepper.prod_frame.f1.info_frame.text delete 1.0 end
    .stepper.prod_frame.f1.info_frame.text configure -state disabled
    .stepper.prod_frame.f2.bindings_frame.text configure -state normal
    .stepper.prod_frame.f2.bindings_frame.text delete 1.0 end  
    .stepper.prod_frame.f2.bindings_frame.text configure -state disabled
    .stepper.prod_frame.f3.production_frame.text configure -state normal
    .stepper.prod_frame.f3.production_frame.text delete 1.0 end
    .stepper.prod_frame.f3.production_frame.text configure -state disabled
  }
}

button .control_panel.step_button \
       -command {select_stepper} -text "Stepper" -font button_font

pack .control_panel.step_button


proc get_tutor_response {word side buf} {
  if {[winfo exists .tutor_response] == 1} {
    tk_messageBox -icon info -type ok -title "Tutoring" \
                  -message "You haven't completed the previous binding yet."
    wm deiconify .tutor_response
    raise .tutor_response

    return 0
  } else {
    # make it now

    global tutor_help
    global tutor_entry
    global tutor_ans

    toplevel .tutor_response
    wm withdraw .tutor_response
    wm title .tutor_response "Tutor Response"

    wm geometry .tutor_response [get_configuration .tutor_response]


    label .tutor_response.label \
          -text "What is the binding for $word?" \
          -justify left -font label_font


    entry .tutor_response.entry \
          -width 50 -textvariable tutor_entry

    set tutor_entry ""

    set tutor_ans ""

    bind .tutor_response.entry <Key-Return> "accept_tutor_response $word"
    
    label .tutor_response.help \
          -textvariable tutor_help \
          -justify left -font label_font \
          -height 2
    
    set tutor_help ""

    button .tutor_response.help_button -text "Help" -font button_font -command "tutor_help $word"
    button .tutor_response.hint_button -text "Hint" -font button_font -command "tutor_hint $word $side $buf"

    bind .tutor_response.entry <Destroy> {
      if {$tutor_ans == ""} {
        set tutor_ans "NoAnswer"
      }
    }    

    pack .tutor_response.label -anchor w
    pack .tutor_response.entry -anchor w
    pack .tutor_response.help -anchor w
    pack .tutor_response.hint_button -side left
    pack .tutor_response.help_button -side left

    wm deiconify .tutor_response

    after idle {focus .tutor_response.entry}

    return 1
  }
}

proc accept_tutor_response {word} {
  global tutor_entry
  global stepper_temp    
  global tutor_help
  global tutor_ans

  set stepper_temp ""

  send_environment_cmd "update [get_handler_name .stepper] (lambda (x) (tutor-check '$word '$tutor_entry))"

  wait_for_non_null stepper_temp

  if $stepper_temp {
    set tutor_ans $tutor_entry
    destroy .tutor_response
    update_instantiation_viewers .stepper.productions.list
        
  } else {
    set tutor_help "Incorrect.\n$tutor_entry is not the binding for $word in this instantiation."
    set tutor_entry ""
  }
}

proc tutor_hint {word side buf} {
  global tutor_help
  global stepper_temp

  set stepper_temp ""

  send_environment_cmd "update [get_handler_name .stepper] (lambda (x) (tutor-completed '$word))"

  wait_for_non_null stepper_temp

  if $stepper_temp {
    set tutor_help "Look in the bindings section of the stepper window\nto see the current binding for $word."
  } elseif {$side == "rhs"} {
    set tutor_help "You should find the binding for $word on\nthe left hand side of the production first."
  } elseif {[string compare -nocase $word "=goal"] == 0 || [string compare -nocase $word "=retrieval"] == 0} {
    set tutor_help "Use the buffer viewer to determine the chunk in the [string range $word 1 end] buffer."
  } elseif {$side == "lhs" && $buf != ""} { 
    set tutor_help "$word is in a slot of the [string range $buf 1 end] buffer.\nYou can find its value using either the buffer viewer or the declarative viewer."
  } else {
    set tutor_help "No hint is available for this variable. (contact Dan because this is an error)"
  }
}

proc tutor_help {word} {
  global tutor_help
  global stepper_temp

  set stepper_temp ""

  send_environment_cmd "update [get_handler_name .stepper] (lambda (x) (tutor-answer '$word))"

  wait_for_non_null stepper_temp
  set tutor_help "The binding of $word is $stepper_temp"
}