proc model_manager {} {
  global current_open_model
  global options_array
  global model_file_names 
  global .model_manager.list.var
  global tutor_mode
  global tutor_windows

  if {$current_open_model == ""} {
    tk_messageBox -icon warning -title "Model Manager" \
                  -message "There is no model open to manage." -type ok
  } else {

    if {[winfo exists .model_manager] == 1} {
      wm deiconify .model_manager
      raise .model_manager
    } else {
      # make it now

      toplevel .model_manager
      wm withdraw .model_manager
      wm title .model_manager "Model Manager"

      wm geometry .model_manager [get_configuration .model_manager]
  
      listbox .model_manager.list -listvar .model_manager.list.var \
                                  -selectmode single \
                                  -exportselection 0 -font list_font
     
      if $tutor_mode {
        set .model_manager.list.var $tutor_windows
      } elseif {$options_array(open_as_split) == 1} {
        set .model_manager.list.var [list "chunk_type" "chunk" \
                                     "production" "misc" "command"]
      } else {
        set .model_manager.list.var [list "model"]
      }
    
      bind .model_manager.list <<ListboxSelect>> "model_manager_selection %W"

      pack .model_manager.list 

      wm deiconify .model_manager
    }
  }
}


button .control_panel.mm_button -text "Model Manager" -font button_font \
       -command {model_manager} 

pack .control_panel.mm_button

proc model_manager_selection {win} {
  global model_file_names

  if {[$win curselection] != ""} {
    set win_name ".[$win get [$win curselection]]"

    if {[winfo exists $win_name] == 1} {
      set reload 0
    } else {
      set reload 1
    }
 
    edit_model_file $win_name $model_file_names($win_name.frame.text) $reload
  }
}
